import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;

import entities.ManufacturedAmount;
import entities.ManufacturedAmountPk;
import entities.Part;
import entities.PartPrimaryKey;

public class Test {

    final static short YEAR = (short) 1900;

    final static String PART_ID = "D-0077";

    final static String PART_VERSION = "1";

    public static void main(String[] args) {
        final EntityManagerFactory emf = Persistence.createEntityManagerFactory("test");
        final EntityManager em = emf.createEntityManager();

        final EntityTransaction tx = em.getTransaction();
        tx.begin();

        final Part part = em.find(Part.class, new PartPrimaryKey(PART_ID, PART_VERSION));
        if (part != null) {
            final ManufacturedAmount manufacturedAmountToSaved = new ManufacturedAmount(part, YEAR);
            em.persist(manufacturedAmountToSaved);
            System.out.println("\nAmount saved.\n");
        } else {
            System.out.println("\nPart not found.\n");
            tx.rollback();
            return;
        }

        tx.commit();

        tx.begin();

        final ManufacturedAmount amount = em.find(ManufacturedAmount.class, new ManufacturedAmountPk(PART_ID, PART_VERSION, YEAR));
        if (amount == null)
            System.out.println("\nAmount = NULL.\n");
        else
            System.out.println(String.format("\n Part = %s\n", amount.getPart() == null ? "NULL" : part.toString()));

        tx.commit();
    }
}