/*
 * Copyright (C) 2008, 2011 QUIPSY QUALITY GmbH & Co. KG
 */

package entities;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Version;

/**
 * 
 * @author Ralf HAMBERGER (hamberger@quipsy.de)
 */
// @Cacheable(false)
@Entity
@NamedQueries({ @NamedQuery(name = "ManufacturedAmount.findAll", query = "SELECT DISTINCT o FROM ManufacturedAmount o") })
public class ManufacturedAmount {

    @EmbeddedId
    private ManufacturedAmountPk pk;

    public ManufacturedAmountPk getPrimaryKey() {
        return this.pk;
    }

    public void setPrimaryKey(final ManufacturedAmountPk pk) {
        this.pk = pk;
    }

    @ManyToOne
    @JoinColumns({ @JoinColumn(name = "partId", referencedColumnName = "ID_TEIL"), @JoinColumn(name = "partVersion", referencedColumnName = "ID_TEILEVERSION") })
    private Part part;

    private Long amountJanuary;

    private Long amountFebruary;

    private Long amountMarch;

    private Long amountApril;

    private Long amountMay;

    private Long amountJune;

    private Long amountJuly;

    private Long amountAugust;

    private Long amountSeptember;

    private Long amountOctober;

    private Long amountNovember;

    private Long amountDecember;

    @Version
    private int version;

    protected ManufacturedAmount() {
        // Intentionally left blank.
    }

    public ManufacturedAmount(final Part part, final short year) {
        this.setPrimaryKey(new ManufacturedAmountPk(part, year));
        this.setPart(part);
        this.setYear(year);
    }

    public Part getPart() {
        return this.part;
    }

    public final void setPart(final Part part) {
        this.part = part;
        this.pk.setPartId(part.getId());
        this.pk.setPartVersion(part.getVersion());
    }

    public final short getYear() {
        return this.pk.getYear();
    }

    public final void setYear(final short year) {
        this.pk.setYear(year);
    }

    public final Long getAmountJanuary() {
        return this.amountJanuary;
    }

    public final void setAmountJanuary(final Long amount) {
        this.amountJanuary = amount;
    }

    public final Long getAmountFebruary() {
        return this.amountFebruary;
    }

    public final void setAmountFebruary(final Long amount) {
        this.amountFebruary = amount;
    }

    public final Long getAmountMarch() {
        return this.amountMarch;
    }

    public final void setAmountMarch(final Long amount) {
        this.amountMarch = amount;
    }

    public final Long getAmountApril() {
        return this.amountApril;
    }

    public final void setAmountApril(final Long amount) {
        this.amountApril = amount;
    }

    public final Long getAmountMay() {
        return this.amountMay;
    }

    public final void setAmountMay(final Long amount) {
        this.amountMay = amount;
    }

    public final Long getAmountJune() {
        return this.amountJune;
    }

    public final void setAmountJune(final Long amount) {
        this.amountJune = amount;
    }

    public final Long getAmountJuly() {
        return this.amountJuly;
    }

    public final void setAmountJuly(final Long amount) {
        this.amountJuly = amount;
    }

    public final Long getAmountAugust() {
        return this.amountAugust;
    }

    public final void setAmountAugust(final Long amount) {
        this.amountAugust = amount;
    }

    public final Long getAmountSeptember() {
        return this.amountSeptember;
    }

    public final void setAmountSeptember(final Long amount) {
        this.amountSeptember = amount;
    }

    public final Long getAmountOctober() {
        return this.amountOctober;
    }

    public final void setAmountOctober(final Long amount) {
        this.amountOctober = amount;
    }

    public final Long getAmountNovember() {
        return this.amountNovember;
    }

    public final void setAmountNovember(final Long amount) {
        this.amountNovember = amount;
    }

    public final Long getAmountDecember() {
        return this.amountDecember;
    }

    public final void setAmountDecember(final Long amount) {
        this.amountDecember = amount;
    }

    public final int getVersion() {
        return this.version;
    }

    public final void setVersion(final int version) {
        this.version = version;
    }

    @Override
    public final String toString() {
        return String.format("%s(pk=(part='%s, 'year='%s'))", getClass().getName() + "@" + Integer.toHexString(hashCode()), this.part, this.pk.getYear());
    }

}
